/*-----------------------------------------------------------------------*/
/*@t@CF	sample2.c											 */
/*	eF			LCD\												 */
/*	tF			2002.6.18											 */
/*	쐬ҁF		OAKS16KIT support									 */
/*-----------------------------------------------------------------------*/

/* CN[ht@C */
#include	"oaks_sfr.h"				/* OAKS16p`t@C */

/* vg^Cv錾 */
void main(void);						/* C֐ */
void lcd_init(void);					/* LCDݒ */
void lcdwriteinit( unsigned char);		/* LCDݒR}ho */
void lcdwrite1command( unsigned char);	/* LCD1R}ho */
void lcdwrite1data( unsigned char );	/* LCD1f[^o */
void wait1( void );						/* 0.1msEGCg */
void wait2( void );						/* 4.1msEGCg */
void wait3( void );						/* 15msEGCg */
unsigned char lcdbusycheck( void );		/* LCDrW[`FbN */

/*   }N`*/
#define PORTIN	0x00			/*|[gWX^͂ɐݒ肷ׂ̃f[^*/
#define	PORTOUT	0xff			/*|[gWX^o͂ɐݒ肷ׂ̃f[^*/
#define	PORTOUTIN	0xf0		/*|[gWX^4rbgo*/
								/*4rbg͂ɐݒ肷ׂ̃f[^*/
#define	LCDRS	p4_6			/* RS[q */
#define	LCDRW	p4_5			/* RW[q */
#define	LCDE	p4_4			/* E[q */
#define	HIGH	1				/* [qógHh */
#define	LOW		0				/* [qógLh */
#define	LCD_COMMAND		0		/* RS-commandw */
#define	LCD_DATA		1		/* RS-dataw */
#define	BUSY	1				/* LCDbuzy */
#define	NOBUSY	0				/* LCDOK */

/* ϐ̐錾 */
const static char pat[2][16]={{' ',' ','W','e','l','c','o','m','e',' ',' ','t','o',' ',' ',' '},
							{' ','O','A','K','S','-','L','C','D','B','o','a','r','d',' ',' '}};
							/*LCD\pf[^ */

/*----------------------------------------------------------------------*/
/* ֐	:mainij													*/
/* @\		:LCD'Welcom to OAKS16 LCDް'\				    */
/*----------------------------------------------------------------------*/

void main(void)
{
	int	i;							/*[vJE^*/
/***	ݒ	***/
	p4 =  0x00;						/*|[g4(LCD)lݒ*/
	pd4 = PORTOUT;					/*|[g4o͂ɐݒ*/
	lcd_init();						/*LCDݒ*/

/***	LCD\   ***/

	while(BUSY == lcdbusycheck())	/*LCDrW[`FbN*/
	;
	lcdwrite1command ( 0x80 );		/*1sڐ擪AhXZbg*/

	for(i=0;i<16;i++)
	{
		while(BUSY == lcdbusycheck())/*LCDrW[`FbN*/
		;
		lcdwrite1data(pat[0][i]);	/*LCDf[^1sڏo*/
	}
	
	while(BUSY == lcdbusycheck())	/*LCDrW[`FbN*/
	;
	lcdwrite1command ( 0xc0 );		/*2sڐ擪AhXZbg*/

	for(i=0;i<16;i++)
	{
		while(BUSY == lcdbusycheck())/*LCDrW[`FbN*/
		;
		
		lcdwrite1data(pat[1][i]);	/*LCDf[^2sڏo*/
	} 

	while(1);						/*[v*/
}
/*----------------------------------------------------------*/
/* ֐	:lcd_init(j									*/
/* @\		:LCDݒ								    */
/*----------------------------------------------------------*/

void lcd_init(void)
{
	wait3();						/*15msEGCg*/
	lcdwriteinit( 0x03 );			/*LCDt@NVZbg*/
	wait2();						/*4.1msEGCg*/
	lcdwriteinit( 0x03 );			/*LCDt@NVZbg*/
	wait1();						/*0.1msEGCg*/
	lcdwriteinit( 0x03 );			/*LCDt@NVZbg*/
	wait1();
	lcdwriteinit( 0x02 );			/*LCDf[^4rbgɐݒ*/
	wait1();
	lcdwrite1command(0x28);			/*4bit2s5~7hbgɐݒ*/
	wait1();

	/* 	܂ł4rbg~2̃f[^]ł悤ɐݒ肳ꂽ̂
	̌̓rW[`FbNĂf[^]sȂB */
	
	while(BUSY == lcdbusycheck())	/*LCDrW[`FbN*/
	;
	lcdwrite1command(0x08);			/*\It*/

	while(BUSY == lcdbusycheck())	/*LCDrW[`FbN*/
	;
	lcdwrite1command(0x01);			/*\NA*/

	while(BUSY == lcdbusycheck())	/*LCDrW[`FbN*/
	;
	lcdwrite1command(0x06);			/*Gg[[hCNg*/

	while(BUSY == lcdbusycheck())	/*LCDrW[`FbN*/
	;
	lcdwrite1command(0x0c);			/*\IJ[\It*/

}
/*----------------------------------------------------------*/
/* ֐	:lcdwriteinit()									*/
/* @\		:LCDݒR}hZbg					    */
/*----------------------------------------------------------*/

void lcdwriteinit( unsigned char command )
{

	p4 = 0x00;				/*P4lZbg@RW|0(Ww) RS|0(R}hwjE|0 */
	pd4 = PORTOUT;			/*P4o͂ɐݒ */

	command &= 0x0f;		/*P4Rg[f[^Zbg(jRW|0(Ww) RS|0(R}hwjE|0 */
	p4 = command;			/*P4Rg[f[^o*/
	LCDE = HIGH;			/*E|P*/
#pragma ASM					/*AZu\L*/
	NOP						/* Ԓׂ̈NOP */
	NOP
	NOP
	NOP
#pragma ENDASM				/*AZu\LI*/
	LCDE = LOW;				/*E|0*/
}
/*----------------------------------------------------------*/
/* ֐	:lcdwrite1command(j							*/
/* @\		:LCDR}ho							    */
/*----------------------------------------------------------*/

void lcdwrite1command( unsigned char command )
{
	unsigned char outcommand;

	p4 = 0x00;				/*P4lZbg@RW|0(Ww) RS|0(R}hwjE|0 */
	pd4 = PORTOUT;			/*P4o͂ɐݒ */

	outcommand = command>>4;/*4rbg4rbg*/
	outcommand &= 0x0f;		/*}XN*/
	p4 = outcommand;		/*R}hf[^4rbgó@RW|0(Ww) RS|0(R}hwjE|0 */

	LCDE = HIGH;			/*E|P*/
#pragma ASM					/*AZu\L*/
	NOP						/*Ԓׂ̈NOP*/
	NOP
	NOP
	NOP
#pragma ENDASM				/*AZu\LI*/
	LCDE = LOW;				/*E|0*/
	
	outcommand = command&0x0f;	/*R}hf[^̉4rbgo(4rbg}XN)*/
	p4 = outcommand;			/*R}hf[^4rbgo*/

	LCDE = HIGH;			/*E|P*/
#pragma ASM					/*AZu\L*/
	NOP						/*Ԓׂ̈NOP*/
	NOP
	NOP
	NOP
#pragma ENDASM					/*AZu\LI*/
	LCDE = LOW;					/*E|0*/

}
/*----------------------------------------------------------*/
/* ֐	:lcdwrite1data(j								*/
/* @\		:LCDf[^o								    */
/*----------------------------------------------------------*/

void	lcdwrite1data( unsigned char data )
{
	unsigned char lcddata;
	p4 = 0x00;				/*P4lZbg@RW|0(Ww) RS|0(R}hwjE|0 */
	pd4 = PORTOUT;			/*P4o͂ɐݒ */

	lcddata = data>>4;		/*LCDf[^4rbg4rbg*/
	lcddata &= 0x0f;		/*}XN*/
	p4 = lcddata;			/*LCDf[^4rbgo*/
	LCDRS = LCD_DATA;		/*RS|1(f[^wj*/
	LCDE = HIGH;			/*E|P*/
#pragma ASM					/*AZu\L*/
	NOP						/* Ԓׂ̈NOP */
	NOP
	NOP
	NOP
#pragma ENDASM				/*AZu\LI*/
	LCDE = LOW;				/*E|0*/
	
	lcddata =data & 0x0f;	/*LCDf[^̉4rbgo(4rbg}XN)*/
	p4 = lcddata;			/*LCDf[^4rbgo*/

	LCDRS = LCD_DATA;		/*RS|1(f[^wj*/
	LCDE = HIGH;			/*E|1*/
#pragma ASM					/*AZu\L*/
	NOP						/* Ԓׂ̈NOP */
	NOP
	NOP
	NOP
#pragma ENDASM				/*AZu\LI*/
	LCDE = LOW;				/*E|0*/
}

/*----------------------------------------------------------*/
/* ֐	:wait1()										*/
/* @\		:0.1msEGCg								    */
/*----------------------------------------------------------*/
void wait1(void){			/* 0.1ms̃EGCg */
#pragma ASM					/*AZu\L*/
	MOV.W 	#0C8H,A0		/*JE^lZbg*/
LOOP1:
	NOP
	NOP
	NOP
	DEC.W	A0
	JNZ	LOOP1				/*[vIH*/
#pragma ENDASM				/*AZu\LI*/
}
/*----------------------------------------------------------*/
/* ֐	:wait2()										*/
/* @\		:4.1msEGCg								    */
/*----------------------------------------------------------*/
void wait2(void){			/* 4.1ms̃EGCg */
#pragma ASM					/*AZu\L*/
	MOV.W 	#2007H,A0		/*JE^lZbg*/
LOOP2:
	NOP
	NOP
	NOP
	DEC.W	A0
	JNZ	LOOP2				/*[vIH*/
#pragma ENDASM				/*AZu\LI*/
}
/*----------------------------------------------------------*/
/* ֐	:wait3()										*/
/* @\		:15msEGCg									*/
/*----------------------------------------------------------*/
void wait3(void){			/* 15ms̃EGCg */
#pragma ASM					/*AZu\L*/
	MOV.W 	#7530H,A0		/*JE^lZbg*/
LOOP3:
	NOP
	NOP
	NOP
	DEC.W	A0
	JNZ	LOOP3				/*[vIH*/
#pragma ENDASM				/*AZu\LI*/
}
/*----------------------------------------------------------*/
/* ֐	:lcdbusycheck()									*/
/* @\		:LCDrW[`FbN							    */
/*----------------------------------------------------------*/

unsigned char lcdbusycheck( void )
{
	unsigned char command_high,command_low,b_data;

	p4 = 0x00;				/*P4lZbg@RW|0(Ww) RS|0(R}hwjE|0 */
	pd4 = PORTOUTIN;		/*|[gWX^4rbgo͉4rbg͂ɐݒ*/

	LCDRW = HIGH;			/*RW|1(Rw)*/

	LCDE = HIGH;			/*E|1*/
#pragma ASM					/*AZu\L*/
	NOP						/* Ԓׂ̈NOP */
	NOP
	NOP
	NOP
#pragma ENDASM				/*AZu\LI*/
	command_high = p4;		/*R}h4rbgǂݍ*/
	LCDE = LOW;				/*E|0*/

	command_high <<=4;		/*4rbgʂ*/
	command_high &= 0xf0;	/*4rbgo(4rbg}XN)*/

	LCDE = HIGH;			/*E|1*/
#pragma ASM					/*AZu\L*/
	NOP						/* Ԓׂ̈NOP */
	NOP
	NOP
	NOP
#pragma ENDASM				/*AZu\LI*/
	command_low = p4;		/*R}h4rbgǂݍ*/
	LCDE = LOW;				/*E|0*/

	command_low &= 0x0f;	/*4rbgo(4rbg}XN)*/
	b_data = command_high|command_low;	/* 24rbgR}hf[^8rbgɂ܂Ƃ߂*/
	b_data &= 0x80;			/*rbg7̃}XN*/
	if(b_data==0)
		b_data = NOBUSY;	/*rbg70ȂLCDokԂ*/
	else
		b_data = BUSY;		/*rbg71ȂLCDbuzyԂ*/
		
	return(b_data);
}
	